﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.3
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	Type BoxData (x As Int, y As Int, vx As Int, vy As Int, bc As BitmapCreator)
	Private xiv As B4XView
	Private bc As BitmapCreator
	Private boxes As List
	Private BoxSize As Int = 20
	Private RunningIndex As Int
End Sub

Public Sub Initialize (parent As B4XView)
	Dim iv As ImageView
	iv.Initialize("")
	xiv = iv
	parent.AddView(iv, 0, 0, parent.Width, parent.Height)
	bc.Initialize(parent.Width / xui.Scale, parent.Height / xui.Scale)
	boxes.Initialize
	Dim NumberOfBoxes As Int
	If xui.IsB4J Then
		NumberOfBoxes = 20000
	Else If xui.IsB4A Then
		NumberOfBoxes = 1000
	Else if xui.IsB4i Then
		NumberOfBoxes = 20000
	End If
	For i = 1 To NumberOfBoxes
		Dim sd As BoxData
		sd.Initialize
		sd.x = Rnd(0, bc.mWidth)
		sd.y = Rnd(0, bc.mHeight)
		sd.vx = Rnd(-5, 5)
		sd.vy = Rnd(-5, 5)
		sd.bc.Initialize(BoxSize, BoxSize)
		sd.bc.FillGradient(Array As Int(Rnd(0xFF000000, -1),Rnd(0xFF000000, -1)), sd.bc.TargetRect, "TL_BR")
		boxes.Add(sd)
	Next
	MainLoop
End Sub

Public Sub Resume
	MainLoop
End Sub

Sub MainLoop
	RunningIndex = RunningIndex + 1
	Dim MyIndex As Int = RunningIndex
	Do While RunningIndex = MyIndex
		Draw
		Sleep(10)
	Loop
End Sub

Sub Draw
	Dim n As Long = DateTime.Now
	bc.FillRect(xui.Color_Transparent, bc.TargetRect)
	For Each sd As BoxData In boxes
		If sd.x + BoxSize >= bc.mWidth Then
			sd.vx = -Abs(sd.vx)
		Else If sd.x < 0 Then
			sd.vx = Abs(sd.vx)
		End If
		sd.x = sd.x + sd.vx
		If sd.y + BoxSize >= bc.mHeight Then
			sd.vy = -Abs(sd.vy)
		Else If sd.y < 2 Then
			sd.vy = Abs(sd.vy)
		End If
		sd.y = sd.y + sd.vy
		bc.DrawBitmapCreator(sd.bc, sd.bc.TargetRect, sd.x, sd.y, True)
	Next
	Log(DateTime.Now - n)
	CallSub2(Main, "ShowDrawingTime", DateTime.Now - n)
	xiv.SetBitmap(bc.Bitmap)
End Sub
